<?php
require('fpdf.php');

class PDF_MySQL_Table extends FPDF
{
var $ProcessingTable=false;
var $aCols=array();
var $TableX;
var $HeaderColor;
var $RowColors;
var $ColorIndex;

function Header()
{
	//Print the table header if necessary
	if($this->ProcessingTable)
		$this->TableHeader();
}

function TableHeader()
{
	$this->SetFont('Arial','B',9);
	//$this->SetX($this->TableX);
	$fill=!empty($this->HeaderColor);
	if($fill)
		$this->SetFillColor($this->HeaderColor[0],$this->HeaderColor[1],$this->HeaderColor[2]);
	foreach($this->aCols as $col)


		$this->Cell($col['w'],10,$col['c'],0,0,$col['a'],$fill);
	$this->Ln();
}

function Row($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 5;
	}
	if($i==1){
	$w = 5;
	}
	if($i==2){
	$w = 5;
	}
	if($i==3){
	$w = 5;
	}
	if($i==4){
	$w = 5;
	}
	if($i==5){
	$w = 5;
	}
	if($i==6){
	$w = 5;
	}
	if($i==7){
	$w = 5;
	}
	if($i==8){
	$w = 5;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
			
		
    $h=90;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 7;
	$a ="L";
	}
	if($i==1){
	$w = 65;
	$a ="L";
	}
	if($i==2){
	$w = 20;
	$a ="R";
	}
	if($i==3){
	$w = 25;
	$a ="R";
	}
	if($i==4){
	$w = 20;
	$a ="R";
	}
	if($i==5){
	$w = 25;
	$a ="R";
	}
	if($i==6){
	$w = 25;
	$a ="R";
	}
	
	if($i==1){
		$n = explode("\n",$data[$i]);
		// $data[$i] = $n[0];
		$h = sizeof($n)*5.5;
	}
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
       // $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','',9);
		if($i==6){
        $this->MultiCell($w,5,$data[$i],0,$a);
		}else{
		  $this->MultiCell($w,5,$data[$i],0,$a);
		}
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}

function Rowboldtestnew($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 90;
	}
	if($i==1){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*1;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 165;
	$a ="L";
	}
	if($i==1){
	$w = 67;
	$a ="R";
	}
	if($i==2){
	$w = 25;
	$a ="R";
	}
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
		if($i==2){
        $this->Rect($x,$y,$w,$h);
		}
        //Print the text
			if($i==0){
		$this->SetFont('Arial','',8);
		}else{
				$this->SetFont('Arial','B',10);
		}
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}


function Rowboldtest($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 100;
	}
	if($i==1){
	$w = 80;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*1;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
    
	if($i==0){
	$w = 115;
	$a ="R";
	}
	//if($i==1){
	//$w = 25;
	//$a ="R";
	//}
	if($i==1){
	$w = 20;
	$a ="R";
	}
	if($i==2){
	$w = 30;
	$a ="R";
	}
	if($i==3){
	$w = 25;
	$a ="R";
	}
	// if($i==2){
	// $w = 20;
	// $a ="R";
	// }
	// if($i==3){
	// $w = 20;
	// $a ="R";
	// }
	// if($i==4){
	// $w = 20;
	// $a ="R";
	// }

	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
		//if($i==1){
      //  $this->Rect($x,$y,$w,$h);
		//}
        //Print the text
		$this->SetFont('Arial','',9);
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}
function Rowall($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 25;
	}
	if($i==2){
	$w = 52;
	}
	if($i==3){
	$w = 15;
	}
	if($i==4){
	$w = 15;
	}
	if($i==5){
	$w = 20;
	}
	if($i==6){
	$w = 20;
	}
	if($i==7){
	$w = 20;
	}
	if($i==8){
	$w = 20;
	}
	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*2;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 20;
		$a ="C";
	}
	if($i==2){
	$w = 37;
	}

	if($i==3){
	$w = 60;
	}
	if($i==4){
	$w = 20;
	$a ="C";
	}
	if($i==5){
	$w = 25;
	$a ="R";
	}
	if($i==6){
	$w = 25;
		$a ="R";
	}
	
	
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
       // $this->Rect($x,$y,$w,$h);
        //Print the text
		$this->SetFont('Arial','',9);
		if($i==6){
        $this->MultiCell($w,$h,$data[$i],R,$a);
		}else{
		  $this->MultiCell($w,$h,$data[$i],LR,$a);
		}
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
    }
    //Go to the next line
    $this->Ln($h);
}
function RowanAtkinson($data)
{

    //Calculate the height of the row
    $nb=0;
    for($i=0;$i<count($data);$i++){
	if($i==0){
	$w = 10;
	}
	if($i==1){
	$w = 10;
	}
	if($i==2){
	$w = 10;
	}

	
    $nb=max($nb,$this->NbLines($w,$data[$i]));
			}
    $h=5*1;

    //Issue a page break first if needed
    $this->CheckPageBreak($h);
    //Draw the cells of the row
    for($i=0;$i<count($data);$i++)
    {

    $a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
	if($i==0){
	$w = 120;
	}
	if($i==1){
	$w = 20;
		$a ="R";
	}
	if($i==2){
	$w = 40;
	$a ="R";
	}


	
	
	
  //$w=$this->widths[$i];
      
        //Save the current position
        $x=$this->GetX();
        $y=$this->GetY();
        //Draw the border
		if($i==1 ){
        $this->Rect(130,203,75,10);
		}
        //Print the text
		if( $i==2){
	$this->SetFont('Arial','B',9);	
        $this->MultiCell($w,5,$data[$i],0,$a);
	}else{
		$this->SetFont('Arial','',9);
			
        $this->MultiCell($w,5,$data[$i],0,$a);
        //Put the position to the right of the cell
        $this->SetXY($x+$w,$y);
	}
    }
    //Go to the next line
    $this->Ln($h);
}
function CheckPageBreak($h)
{
    //If the height h would cause an overflow, add a new page immediately
    if($this->GetY()+$h>$this->PageBreakTrigger)
        $this->AddPage($this->CurOrientation);
}
function NbLines($w,$txt)
{
    //Computes the number of lines a MultiCell of width w will take
    $cw=&$this->CurrentFont['cw'];
    if($w==0)
        $w=$this->w-$this->rMargin-$this->x;
    $wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
    $s=str_replace("\r",'',$txt);
    $nb=strlen($s);
    if($nb>0 and $s[$nb-1]=="\n")
        $nb--;
    $sep=-1;
    $i=0;
    $j=0;
    $l=0;
    $nl=1;
    while($i<$nb)
    {
        $c=$s[$i];
        if($c=="\n")
        {
            $i++;
            $sep=-1;
            $j=$i;
            $l=0;
            $nl++;
            continue;
        }
        if($c==' ')
            $sep=$i;
        $l+=$cw[$c];
        if($l>$wmax)
        {
            if($sep==-1)
            {
                if($i==$j)
                    $i++;
            }
            else
                $i=$sep+1;
            $sep=-1;
            $j=$i;
            $l=0;
            $nl++;
        }
        else
            $i++;
    }
    return $nl;
}

function CalcWidths($width,$align)
{
	//Compute the widths of the columns
	$TableWidth=0;
	foreach($this->aCols as $i=>$col)
	{
		$w=$col['w'];
		if($w==-1)
			$w=$width/count($this->aCols);
		elseif(substr($w,-1)=='%')
			$w=$w/100*$width;
		$this->aCols[$i]['w']=$w;
		$TableWidth+=$w;
	}
	//Compute the abscissa of the table
	if($align=='C')
		$this->TableX=max(($this->w-$TableWidth)/2,0);
	elseif($align=='R')
		$this->TableX=max($this->w-$this->rMargin-$TableWidth,0);
	else
		$this->TableX=$this->lMargin;
}

function AddCol($field=-1,$width=-1,$caption='',$align)
{
	//Add a column to the table
	if($field==-1)
		$field=count($this->aCols);
	$this->aCols[]=array('f'=>$field,'c'=>$caption,'w'=>$width,'a'=>$align);
}

function Table($query,$prop=array(),$id)
{
	//Issue query
	$res=mysql_query($query) or die('Error: '.mysql_error()."<BR>Query: $query");
	//Add all columns if none was specified
	if(count($this->aCols)==0)
	{
		$nb=mysql_num_fields($res);
		for($i=0;$i<$nb;$i++)
			$this->AddCol();
	}
	//Retrieve column names when not specified
	foreach($this->aCols as $i=>$col)
	{
		if($col['c']=='')
		{
			if(is_string($col['f']))
				$this->aCols[$i]['c']=ucfirst($col['f']);
			else
				$this->aCols[$i]['c']=ucfirst(mysql_field_name($res,$col['f']));
		}
	}
	//Handle properties
	if(!isset($prop['width']))
		$prop['width']=0;
	if($prop['width']==0)
		$prop['width']=$this->w-$this->lMargin-$this->rMargin;
	if(!isset($prop['align']))
		$prop['align']='C';
	if(!isset($prop['padding']))
		$prop['padding']=$this->cMargin;
	$cMargin=$this->cMargin;
	$this->cMargin=$prop['padding'];
	if(!isset($prop['HeaderColor']))
		$prop['HeaderColor']=array();
	$this->HeaderColor=$prop['HeaderColor'];
	if(!isset($prop['color1']))
		$prop['color1']=array();
	if(!isset($prop['color2']))
		$prop['color2']=array();
	$this->RowColors=array($prop['color1'],$prop['color2']);
	//Compute column widths
	$this->CalcWidths($prop['width'],$prop['align']);
	//Print header
	$this->TableHeader();
	//Print rows
	$this->SetFont('Arial','',11);
	$this->ColorIndex=0;
	$this->ProcessingTable=true;
	$a=1;
	$dataprint = array();
	$dataprint2 = array();
	//$this->SetX($this->TableX);
	$r =1;
	while($row=mysql_fetch_array($res)){
		$subamount = ($row['price']*$row['qty'])-$row['discount'];
		$taxamount = ($subamount*$row['taxpercent'])/100;
		$tsubamount += $subamount;
		$ttaxamount += $taxamount;
		$twsubamount += $subamount;
		
		$dataprint[0] = $r;
		$dataprint[1] = $row[name]."\n";
		//$dataprint[1] = $row[name];
		$dataprint[2] = number_format($row[qty],2,'.',',');
		$dataprint[3] = number_format($row[price],2,'.',',');
	    $unitprice = $row[price];
		$subamount = ($row['price']*$row['qty'])-$row['discount'];
		$tax = $row['taxpercent'];
		$taxamount = ($subamount*$row['taxpercent'])/100;
		// $totalamount= $subamount+$ttaxamount;
		$totalamount= $subamount;

		// $dataprint[4] = number_format($subamount,2,'.',',')."";
		// $dataprint[5] = number_format($ttaxamount,2,'.',',');
		$dataprint[4] = number_format($totalamount,2,'.',',');
		$dataprint[5] = number_format($taxamount,2,'.',',');
		$dataprint[6] = number_format($subamount+$taxamount,2,'.',',');
		
		
		$this->Row($dataprint);
		$a+=1;
		$tunitprice += number_format($unitprice,2,'.','');
		$toexl += number_format($subamount,2,'.','');
		$togst += number_format($taxamount,2,'.','');
		$r+=1;
	}
	$num = number_format($toexl+$togst,2,'.','');
	$nw = new Numbers_Words();
	
	//get invoice header 
	$sql1= "SELECT * FROM debtor_invoice where id='$id'";
    $result = mysql_query($sql1);
    $dbinv= mysql_fetch_array($result);
	
	if($dbinv[currency]=="USD" && $r>1){
	    $dataprint[0] = "";
		$dataprint[1] = $dbinv[remark];
		$dataprint[2] = "";
		$dataprint[3] = "";
		$dataprint[4] = "";
		$dataprint[5] = "";
		$dataprint[6] = "";
		
		
		$this->Row($dataprint);
	}
	
	//get currency 
	$sql1= "select * from currency_code where code='$dbinv[currency]'";
	$result = mysql_query($sql1);
	$currency= mysql_fetch_array($result);
	$cduit = $currency[name]." : ".strtoupper($nw->toCurrency($num));
	
	$this->SetXY($x+8,193);
	$sql1= "SELECT * FROM inv where id='$id'";
	$result = mysql_query($sql1);
	$cv= mysql_fetch_array($result);
		$dataprint2[0] = 	$cduit;

	$this->Rowboldtestnew($dataprint2);
	$this->Line(5, 198, 206, 198);


	
	$this->SetXY($x+8,198);
		$dataprint3[0] = "Total Amount Due";
		// $dataprint3[1] = number_format($toexl,2,'.',',');
		// $dataprint3[2] = number_format($toexl,2,'.',',');
		// $dataprint3[3] = number_format($togst,2,'.',',');
		//$dataprint3[1] = number_format($tunitprice,2,'.',',');
		$dataprint3[1] = number_format($toexl,2,'.',',');
		$dataprint3[2] = number_format($togst,2,'.',',');
		$dataprint3[3] = number_format($num,2,'.',',');
	$this->Rowboldtest($dataprint3);
	
	$this->SetXY($x+18,203);
		$dataprint4[0] = "";
		$dataprint4[1] = "Tax Amount \n".number_format($togst,2,'.',',');
		$dataprint4[2] = "Total Payable (".$dbinv[currency].") \n".number_format($num,2,'.',',');
	$this->RowanAtkinson($dataprint4);
	

	
$this->ProcessingTable=false;
	$this->cMargin=$cMargin;
	$this->aCols=array();
}
}
?>
